
package de.ivu.elect.presentation.stimmzettel;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumConversationStore;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumExtendedDAO;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumEdit;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractStimmzettelKopfdatumEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractStimmzettelKopfdatumEditNoScopeView.VIEW_ID, useCase = UseCasePermission.STIMMZETTEL_KOPFDATUM_EDIT)
public abstract class AbstractStimmzettelKopfdatumEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<StimmzettelKopfdatum>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmzettelKopfdatumEditView";

  public static final String VIEW_ID = "/stimmzettel/stimmzettel-kopfdatum-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/stimmzettel/stimmzettel-kopfdatum-search.xhtml";

  @Inject
  protected transient StimmzettelKopfdatumExtendedDAO extendedDAO;

  @Inject
  protected transient StimmzettelKopfdatumEdit edit;

  @Inject
  @ConversationGroup(StimmzettelKopfdatumConversationStore.class)
  protected transient StimmzettelKopfdatumConversationStore conversationStore;

  @Inject
  protected transient StimmzettelKopfdatumMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient StimmzettelKopfdatumEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public StimmzettelKopfdatum getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(StimmzettelKopfdatum entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STIMMZETTEL_KOPFDATUM_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(StimmzettelKopfdatum entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.STIMMZETTEL_KOPFDATUM_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.STIMMZETTEL_KOPFDATUM_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STIMMZETTEL_KOPFDATUM_EDIT)
  @Override
  public String save() {
    StimmzettelKopfdatum entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(StimmzettelKopfdatum entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    StimmzettelKopfdatum entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(StimmzettelKopfdatum entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.STIMMZETTEL_KOPFDATUM_EDIT);
  }
  
  @Redirect
  public String edit(StimmzettelKopfdatum entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class StimmzettelKopfdatumEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<StimmzettelKopfdatum,   de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK  > {

    private static final long serialVersionUID = 1L;
  }
}
